#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <vibrant.h>

#include "clustalw.h"

/*
*	Prototypes
*/

extern void *ckalloc(size_t);
extern void init_interface(void);
extern void parse_params(Boolean);
extern void x_menu(void);

/*
*	Global variables
*/
double **tmat;

char revision_level[] = "G (1.2)";
Boolean interactive=TRUE;
#ifdef MSDOS
        char *help_file_name = "clustalg.hlp";
#else
        char *help_file_name = "clustalg_help";
#endif

sint max_names; /* maximum length of names in current alignment file */
 
FILE *fin,*tree;
FILE *clustal_outfile, *gcg_outfile, *nbrf_outfile, *phylip_outfile,
     *gde_outfile;
sint  *seqlen_array;
sint max_aln_length;
short *usermat=NULL, *pw_usermat=NULL;
short *score_matrix=NULL;
short *segment_matrix=NULL;
sint nseqs;
sint nsets;
sint *output_index;
sint **sets;
sint *seq_weight;
sint max_aa;
sint gap_pos1;
sint gap_pos2;
sint GAPCOL;
sint LENCOL;
sint mat_avscore;
sint profile_no;


Boolean usemenu;
Boolean dnaflag;
Boolean distance_tree;

ECHAR  **seq_array;
char **names,**titles;
char **args;
char seqname[FILENAMELEN+1];

char *gap_penalty_mask1 = NULL, *gap_penalty_mask2 = NULL;
char *sec_struct_mask1 = NULL, *sec_struct_mask2 = NULL;
sint struct_penalties;
char *ss_name1 = NULL, *ss_name2 = NULL;

extern Int2 Main(void)
 
{
	int i;

#ifndef WIN_MAC
#ifdef GetArgc
	int argc;
	char **argv;
	
	argc=GetArgc();
	argv=GetArgv();
#else
	extern int argc;
	extern char **argv;
#endif
#endif

    init_interface();
	


#ifndef WIN_MAC
	if(argc>1) {
               args = (char **)ckalloc(argc * sizeof(char *));

                for(i=1;i<argc;++i)
                {
                        args[i-1]=(char *)ckalloc(strlen(argv[i]+1) * sizeof(char));
                        strcpy(args[i-1],argv[i]);
                }
                usemenu=FALSE;
                parse_params(TRUE);

                for(i=0;i<argc-1;i++)
                        ckfree(args[i]);
                ckfree(args);

	}
#endif

	x_menu();
	
	return 0;
}

