/* command line interface for Clustal W  */
/* DES was here MARCH. 1994 */
/* DES was here SEPT.  1994 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <signal.h>
#include <setjmp.h>
#include "clustalw.h"
#include "param.h"

/*
*	Prototypes
*/

#ifdef UNIX
FILE    *open_path(char *);
#endif


static sint check_param(char **args,char *params[], char *param_arg[]);
static void set_optional_param(void);
static sint find_match(char *probe, char *list[], sint n);
static void create_parameter_output(void);
static void reset_align(void);
static void reset_prf1(void);
static void reset_prf2(void);
/*
*        Global variables
*/

extern sint max_names;

extern Boolean interactive;

extern double  **tmat;
extern float pw_go_penalty, pw_ge_penalty;
extern float gap_open,gap_extend;
extern char     revision_level[];
extern sint    wind_gap,ktup,window,signif;
extern sint     boot_ntrials;           /* number of bootstrap trials */
extern sint     nseqs;
extern sint     new_seq;
extern sint     *seqlen_array;
extern sint     divergence_cutoff;
extern sint     debug;
extern Boolean  neg_matrix;
extern Boolean  quick_pairalign;
extern Boolean  reset_alignments_new;           /* DES */
extern Boolean  reset_alignments_all;           /* DES */
extern sint     gap_dist;
extern sint     max_aa;
extern sint     gap_pos1, gap_pos2;
extern sint     max_aln_length;
extern sint     *output_index, output_order;
extern sint profile_no;
extern void    *usermat, *pw_usermat;
extern sint     *seq_weight;
extern Boolean  lowercase; /* Flag for GDE output - set on comm. line*/
extern Boolean  cl_seq_numbers;
extern Boolean  output_clustal, output_nbrf, output_phylip, output_gcg,output_gde;
extern Boolean  output_tree_clustal, output_tree_phylip, output_tree_distances;
extern sint     bootstrap_format;
extern Boolean  tossgaps;
extern Boolean  percent;
extern Boolean  usemenu;
extern Boolean  showaln, save_parameters;
extern unsigned sint boot_ran_seed;

extern Boolean save_log;

extern FILE     *tree;
extern FILE     *clustal_outfile, *gcg_outfile, *nbrf_outfile, *phylip_outfile;
extern FILE     *gde_outfile;

extern DCHAR     *alphabet;
extern char     **args;
extern char     seqname[];

extern ECHAR     **seq_array;
extern char     **names, **titles;

extern char *gap_penalty_mask1,*gap_penalty_mask2;
extern sint struct_penalties,struct_penalties1,struct_penalties2;
extern sint output_struct_penalties;
extern Boolean use_ss1, use_ss2;
extern char *ss_name1,*ss_name2;

char save_log_filename[FILENAMELEN+1];
FILE *save_log_fd;
char *ss_name = NULL;
char *gap_penalty_mask = NULL;

char    profile1_name[FILENAMELEN+1];
char    profile2_name[FILENAMELEN+1];

Boolean empty;
Boolean profile1_empty, profile2_empty;   /* whether or not profiles   */

char    outfile_name[FILENAMELEN+1]="";

static char     clustal_outname[FILENAMELEN+1], gcg_outname[FILENAMELEN+1];
static char     phylip_outname[FILENAMELEN+1],nbrf_outname[FILENAMELEN+1];
static char     gde_outname[FILENAMELEN+1];

char     clustal_tree_name[FILENAMELEN+1]="";
char     dist_tree_name[FILENAMELEN+1]="";
char    phylip_tree_name[FILENAMELEN+1]="";
char    p1_tree_name[FILENAMELEN+1]="";
char    p2_tree_name[FILENAMELEN+1]="";


static char *params[MAXARGS];
static char *param_arg[MAXARGS];

static char *cmd_line_type[] = {
                " ",
                "=n ",
                "=f ",
                "=string ",
                "=filename ",
                ""};

static sint numparams;
static Boolean check_tree = TRUE;

sint    profile1_nseqs; /* have been filled; the no. of seqs in prof 1*/
Boolean use_tree_file = FALSE,new_tree_file = FALSE;
Boolean use_tree1_file = FALSE, use_tree2_file = FALSE;
Boolean new_tree1_file = FALSE, new_tree2_file = FALSE;

static char *lin2;

MatMenu matrix_menu = {2,
                "Identity matrix","id",
                "User defined",""
                };

MatMenu pw_matrix_menu = {2,
                "Identity matrix","id",
                "User defined",""
                };

void init_interface(void)
{
        empty=TRUE;

        profile1_empty = TRUE;     /*  */
        profile2_empty = TRUE;     /*  */

        lin2 = (char *)ckalloc( (MAXLINE+1) * sizeof (char) );

}



static sint check_param(char **args,char *params[], char *param_arg[])
{

/*
#ifndef MAC
        char *strtok(char *s1, const char *s2);
#endif
*/
        sint     len,i,j,k,s,n,match[MAXARGS];
                Boolean         name1 = FALSE;


        if(args[0]==NULL) return 0;

        params[0]=(char *)ckalloc((strlen(args[0])+1)*sizeof(char));
        if (args[0][0]!=COMMANDSEP)
        {
                name1 = TRUE;
                strcpy(params[0],args[0]);
        }
        else
                strcpy(params[0],&args[0][1]);

        for (i=1;i<MAXARGS;i++) {
                if(args[i]==NULL) break;
                params[i]=(char *)ckalloc(strlen(args[i])*sizeof(char));
                strcpy(params[i],&args[i][1]);
        }
        if (i==MAXARGS) {
                fprintf(stdout,"Error: too many command line arguments\n");
                return(-1);
        }
/*
    special case - first parameter is input filename
*/
        s = 0;
        if(name1 == TRUE) {
                strcpy(seqname, params[0]);
/*  JULIE
    convert to lower case now
*/
#ifndef UNIX
                for(k=0;k<(sint)strlen(params[0]);++k) seqname[k]=tolower(params
[0][k]);
#else
                for(k=0;k<(sint)strlen(params[0]);++k) seqname[k]=params[0][k];
#endif
                s++;
        }

        n = i;
    for (i=s;i<n;i++) {
        param_arg[i] = NULL;
                len = (sint)strlen(params[i]);
                for(j=0; j<len; j++)
                        if(params[i][j] == '=') {
                                param_arg[i] = (char *)ckalloc((len-j) * sizeof(
char));
                                strncpy(param_arg[i],&params[i][j+1],len-j-1);
                                params[i][j] = EOS;
/*  JULIE
    convert keywords to lower case now
*/
                                for(k=0;k<j;++k) params[i][k]=tolower(params[i][
k]);
                                param_arg[i][len-j-1] = EOS;
                                break;
                        }
        }

/*
    for each parameter given on the command line, first search the list of recog
nised optional
    parameters....
*/

    for (i=0;i<n;i++) {
                if ((i==0) && (name1 == TRUE)) continue;
                j = 0;
                match[i] = -1;
                for(;;) {
                        if (cmd_line_para[j].str[0] == '\0') break;
                        if (!strcmp(params[i],cmd_line_para[j].str)) {
                                match[i] = j;
                                *cmd_line_para[match[i]].flag = i;
                                if ((cmd_line_para[match[i]].type != NOARG) &&
                                    (param_arg[i] == NULL)) {
                                        fprintf(stdout,
                                                 "Error: parameter required for %s\n",params[i]);
                                        exit(1);
                                }
/*  JULIE
    convert parameters to lower case now, unless the parameter is a filename
*/
#ifdef UNIX
                                else if (cmd_line_para[match[i]].type != FILARG
                                         && param_arg[i] != NULL)
#endif
                                if (param_arg[i]!=0)
                                        {
                                        for(k=0;k<strlen(param_arg[i]);++k)
param_arg[i][k]=tolower(param_arg[i][k]);
                                        }
                                break;
                        }
                        j++;
                }
        }
/*
    ....then the list of recognised input files,....
*/
    for (i=0;i<n;i++) {
                if ((i==0) && (name1 == TRUE)) continue;
                if (match[i] != -1) continue;
                j = 0;
                for(;;) {
                        if (cmd_line_file[j].str[0] == '\0') break;
                        if (!strcmp(params[i],cmd_line_file[j].str)) {
                                match[i] = j;
                                *cmd_line_file[match[i]].flag = i;
                                if ((cmd_line_file[match[i]].type != NOARG) &&
                                    (param_arg[i] == NULL)) {
                                        fprintf(stdout,
                                                 "Error: parameter required for /%s\n",params[i]);
                                        exit(1);
                                }
                                break;
                        }
                        j++;
                }
        }
/*
        ....and finally the recognised verbs.
*/
    for (i=0;i<n;i++) {
                if ((i==0) && (name1 == TRUE)) continue;
                if (match[i] != -1) continue;
                j = 0;
                for(;;) {
                        if (cmd_line_verb[j].str[0] == '\0') break;
                        if (!strcmp(params[i],cmd_line_verb[j].str)) {
                                match[i] = j;
                                *cmd_line_verb[match[i]].flag = i;
                                if ((cmd_line_verb[match[i]].type != NOARG) &&
                                    (param_arg[i] == NULL)) {
                                        fprintf(stdout,
                                                 "Error: parameter required for /%s\n",params[i]);
                                        exit(1);
                                }
                                break;
                        }
                        j++;
                }
        }

/*
        check for any unrecognised parameters.
*/
    for (i=0;i<n;i++) {
                if (match[i] == -1) {
                        fprintf(stdout,
                        "Error: unknown option %c%s\n",COMMANDSEP,params[i]);
                        exit(1);
                }
        }
        return(n);
}
static void set_optional_param(void)
{
        int i,temp;
        float ftemp;
        char tstr[100];
	void *matptr;

/****************************************************************************/
/* look for parameters on command line  e.g. gap penalties, k-tuple etc.    */
/****************************************************************************/

/*** ? /score=percent or /score=absolute */
        if(setscore != -1)
                if(strlen(param_arg[setscore]) > 0) {
                        temp = find_match(param_arg[setscore],score_arg,2);
                        if(temp == 0)
                                percent = TRUE;
                        else if(temp == 1)
                                percent = FALSE;
                        else
                                fprintf(stdout,"\nUnknown SCORE type: %s\n",
                                param_arg[setscore]);
                }


/*** ? /seed=n */
        if(setseed != -1) {
                temp = 0;
                if(strlen(param_arg[setseed]) > 0)
                         if (sscanf(param_arg[setseed],"%d",&temp)!=1) {
                                fprintf(stdout,"Bad option for /seed (must be integer)\n");
                                temp = 0;
                         }
                if(temp > 0) boot_ran_seed = temp;
        }

/*** ? /outlen=n */
        if(setoutlen != -1) {
                temp = 0;
                if(strlen(param_arg[setoutlen]) > 0)
                         if (sscanf(param_arg[setoutlen],"%d",&temp)!=1) {
                                fprintf(stdout,"Bad option for /outlen (must be integer)\n");
                                temp = 0;
                         }
                if(temp > 0) cl_linewidth = temp;
        }




/*** ? /output=PIR, GCG, GDE or PHYLIP */
                if(setoutput != -1)
                if(strlen(param_arg[setoutput]) > 0) {
                        temp = find_match(param_arg[setoutput],output_arg,4);
                        if (temp >= 0 && temp <= 3) {
                                output_clustal = FALSE;
                                output_gcg     = FALSE;
                                output_phylip  = FALSE;
                                output_nbrf    = FALSE;
                                output_gde     = FALSE;
                        }
                        switch (temp) {
                                case 0: /* GCG */
                                        output_gcg     = TRUE;
                                        break;
                                case 1: /* GDE */
                                        output_gde     = TRUE;
                                        break;
                                case 2: /* PIR */
                                        output_nbrf    = TRUE;
                                        break;
                                case 3: /* PHYLIP */
                                        output_phylip  = TRUE;
                                        break;
                               default:
                                        fprintf(stdout,"\nUnknown OUTPUT type: %s\n",
                                        param_arg[setoutput]);
                        }
                }

/*** ? /outputtree=NJ or PHYLIP or DIST */
        if(setoutputtree != -1)
                if(strlen(param_arg[setoutputtree]) > 0) {
                        temp = find_match(param_arg[setoutputtree],outputtree_arg,3);
                        switch (temp) {
                                case 0: /* NJ */
                                        output_tree_clustal = TRUE;
                                        break;
                                case 1: /* PHYLIP */
                                        output_tree_phylip  = TRUE;
                                        break;
                                case 2: /* DIST */
                                        output_tree_distances = TRUE;
                                        break;
                                default:
                                        fprintf(stdout,"\nUnknown OUTPUT TREE type: %s\n",
                                        param_arg[setoutputtree]);
                        }
                }

/*** ? /profile (sets type of second input file to profile) */
        if(setprofile != -1)
                profile_type = PROFILE;

/*** ? /sequences (sets type of second input file to list of sequences)  */
        if(setsequences != -1)
                profile_type = SEQUENCE;



/*** ? /ktuple=n */
        if(setktuple != -1) {
                temp = 0;
                if(strlen(param_arg[setktuple]) > 0)
                                        if (sscanf(param_arg[setktuple],"%d",&temp)!=1) {
                         fprintf(stdout,"Bad option for /ktuple (must be integer)\n");
                         temp = 0;
                    }
                if(temp > 0) {
                                if(temp <= 2) {
                                        ktup          = temp;
                                        wind_gap      = ktup + 3;
                                }
                }
        }

/*** ? /pairgap=n */
        if(setpairgap != -1) {
                temp = 0;
                if(strlen(param_arg[setpairgap]) > 0)
                                        if (sscanf(param_arg[setpairgap],"%d",&temp)!=1) {
                         fprintf(stdout,"Bad option for /pairgap (must be integer)\n");
                         temp = 0;
                    }
                if(temp > 0)
                                if(temp > ktup) {
                                        wind_gap      = temp;
                                }
        }


/*** ? /topdiags=n   */
        if(settopdiags != -1) {
                temp = 0;
                if(strlen(param_arg[settopdiags]) > 0)
                                        if (sscanf(param_arg[settopdiags],"%d",&
temp)!=1) {
                         fprintf(stdout,"Bad option for /topdiags (must be integer)\n");
                         temp = 0;
                    }
                if(temp > 0)
                                if(temp > ktup) {
                                        signif        = temp;
                                }
        }


/*** ? /window=n  */
        if(setwindow != -1) {
                temp = 0;
                if(strlen(param_arg[setwindow]) > 0)
                                        if (sscanf(param_arg[setwindow],"%d",&temp)!=1) {
                         fprintf(stdout,"Bad option for /window (must be integer)\n");
                         temp = 0;
                    }
                if(temp > 0)
                                if(temp > ktup) {
                                        window        = temp;
                                }
        }

/*** ? /tossgaps */
        if(settossgaps != -1)
                tossgaps = TRUE;


/*** ? /negative  */
        if(setnegative != -1)
                neg_matrix = TRUE;

/*** ? /chargapfile=str (user's file)  */
        if(setgappenfile != -1)
        {
                temp=strlen(param_arg[setgappenfile]);
                if(temp > 0) {
			if(gappenfile != NULL) ckfree(gappenfile);
                        if(user_gappen(param_arg[setgappenfile]))
                        {
                               strcpy(gappenfile,param_arg[setgappenfile]);
                        }
                        else exit(1);
                }
        }

/*** ? /pwmatrix=ID (user's file)  */
        if(setpwmatrix != -1)
        {
                temp=strlen(param_arg[setpwmatrix]);
                if(temp > 0) {
                        for(i=0;i<temp;i++)
                                if (isupper(param_arg[setpwmatrix][i]))
                                        tstr[i]=tolower(param_arg[setpwmatrix][i
]);
                                else
                                        tstr[i]=param_arg[setpwmatrix][i];
                        tstr[i]='\0';
                        if (strcmp(tstr,"id")==0) {
                                strcpy(pw_mtrxname, tstr);
                                pw_matnum = 1;
                        }
                        else {
                                if((matptr=user_mat(param_arg[setpwmatrix]))!=0)
                                  {
				     if(pw_usermat != NULL) ckfree(pw_usermat);
				     pw_usermat=matptr;
                                     strcpy(pw_mtrxname,param_arg[setpwmatrix]);
                                     strcpy(pw_usermtrxname,param_arg[setpwmatrix]);
                                     pw_matnum=2;
                                  }
                                else exit(1);
                        }

                }
        }

/*** ? /matrix=ID (user's file)  */
        if(setmatrix != -1)
        {
                temp=strlen(param_arg[setmatrix]);
                if(temp > 0) {
                        for(i=0;i<temp;i++)
                                if (isupper(param_arg[setmatrix][i]))
                                        tstr[i]=tolower(param_arg[setmatrix][i])
;
                                else
                                        tstr[i]=param_arg[setmatrix][i];
                        tstr[i]='\0';
                        if (strcmp(tstr,"id")==0) {
                                strcpy(mtrxname, tstr);
                                matnum = 1;
                        }
                        else {
                                if((matptr=user_mat(param_arg[setmatrix]))!=0)
                                  {
				     if(usermat != NULL) ckfree(usermat);
				     usermat=matptr;
                                     strcpy(mtrxname,param_arg[setmatrix]);
                                     strcpy(usermtrxname,param_arg[setmatrix]);
                                     matnum=2;
                                  }
                                else exit(1);
                        }

                }
        }

/*** ? /maxdiv= n */
        if(setmaxdiv != -1) {
                temp = 0;
                if(strlen(param_arg[setmaxdiv]) > 0)
                        if (sscanf(param_arg[setmaxdiv],"%d",&temp)!=1) {
                 fprintf(stdout,"Bad option for /maxdiv (must be integer)\n");
                 temp = 0;
            }
                if (temp >= 0)
                        divergence_cutoff = temp;
        }

/*** ? /gapdist= n */
        if(setgapdist != -1) {
                temp = 0;
                if(strlen(param_arg[setgapdist]) > 0)
                        if (sscanf(param_arg[setgapdist],"%d",&temp)!=1) {
                         fprintf(stdout,"Bad option for /gapdist (must be integer)\n");
                         temp = 0;
                    }
                if (temp >= 0)
                        gap_dist = temp;
        }

/*** ? /debug= n */
        if(setdebug != -1) {
                temp = 0;
                if(strlen(param_arg[setdebug]) > 0)
                        if (sscanf(param_arg[setdebug],"%d",&temp)!=1) {
                         fprintf(stdout,"Bad option for /debug (must be integer)\n");
                         temp = 0;
                    }
                if (temp >= 0)
                        debug = temp;
        }

/*** ? /outfile= (user's file)  */
        if(setoutfile != -1)
                if(strlen(param_arg[setoutfile]) > 0) {
                        strcpy(outfile_name, param_arg[setoutfile]);
                }

/*** ? /case= lower/upper  */
        if(setcase != -1)
                if(strlen(param_arg[setcase]) > 0) {
                        temp = find_match(param_arg[setcase],case_arg,2);
                        if(temp == 0) {
                                lowercase = TRUE;
                        }
                        else if(temp == 1) {
                                lowercase = FALSE;
                        }
                        else
                                fprintf(stdout,"\nUnknown case %s\n",
                                param_arg[setcase]);
                }

/*** ? /seqnos=off/on  */
        if(setseqno != -1)
                if(strlen(param_arg[setseqno]) > 0) {
                        temp = find_match(param_arg[setseqno],seqno_arg,2);
                        if(temp == 0) {
                                cl_seq_numbers = FALSE;
                        }
                        else if(temp == 1) {
                                cl_seq_numbers = TRUE;
                        }
                        else
                                fprintf(stdout,"\nUnknown SEQNO option %s\n",
                                param_arg[setseqno]);
                }


/*** ? /gapopen=n  */
        if(setgapopen != -1) {
                ftemp = 0.0;
                if(strlen(param_arg[setgapopen]) > 0)
                        if (sscanf(param_arg[setgapopen],"%f",&ftemp)!=1) {
                         fprintf(stdout,"Bad option for /gapopen (must be real number)\n");
                         ftemp = 0.0;
                    }
                if(ftemp >= 0.0)
                        {
                                        gap_open      = ftemp;
                        }
        }


/*** ? /gapext=n   */
        if(setgapext != -1) {
                ftemp = 0.0;
                if(strlen(param_arg[setgapext]) > 0)
                        if (sscanf(param_arg[setgapext],"%f",&ftemp)!=1) {
                         fprintf(stdout,"Bad option for /gapext (must be real number)\n");
                         ftemp = 0.0;
                    }
                if(ftemp >= 0)
                        {
                                        gap_extend      = ftemp;
                        }
        }


/*** ? /pwgapopen=n  */
        if(setpwgapopen != -1) {
                ftemp = 0.0;
                if(strlen(param_arg[setpwgapopen]) > 0)
                        if (sscanf(param_arg[setpwgapopen],"%f",&ftemp)!=1) {
                         fprintf(stdout,"Bad option for /pwgapopen (must be real number)\n");
                         ftemp = 0.0;
                    }
                if(ftemp >= 0.0)
                        {
                                        pw_go_penalty  = ftemp;
                        }
        }


/*** ? /gapext=n   */
        if(setpwgapext != -1) {
                ftemp = 0.0;
                if(strlen(param_arg[setpwgapext]) > 0)
                        if (sscanf(param_arg[setpwgapext],"%f",&ftemp)!=1) {
                         fprintf(stdout,"Bad option for /pwgapext (must be real number)\n");
                         ftemp = 0.0;
                    }
                if(ftemp >= 0)
                        {
                                        pw_ge_penalty  = ftemp;
                        }
        }



/*** ? /outorder=n  */
        if(setoutorder != -1) {
                if(strlen(param_arg[setoutorder]) > 0)
                        temp = find_match(param_arg[setoutorder],outorder_arg,2)
;
                        if(temp == 0)  {
                                output_order   = INPUT;
                        }
                        else if(temp == 1)  {
                                output_order   = ALIGNED;
                        }
                        else
                                fprintf(stdout,"\nUnknown OUTPUT ORDER type %s\n",
                                param_arg[setoutorder]);
        }

/*** ? /bootlabels=n  */
        if(setbootlabels != -1) {
                if(strlen(param_arg[setbootlabels]) > 0)
                        temp = find_match(param_arg[setbootlabels],bootlabels_arg,2);
                        if(temp == 0)  {
                                bootstrap_format   = BS_NODE_LABELS;
                        }
                        else if(temp == 1)  {
                                bootstrap_format   = BS_BRANCH_LABELS;
                        }
                        else
                                fprintf(stdout,"\nUnknown bootlabels type %s\n",
				param_arg[setoutorder]);
	}

/*** ? /endgaps */
	if(setuseendgaps != -1)
		use_endgaps = FALSE;

	profile2_empty = TRUE;     /*  */

        lin2 = (char *)ckalloc( (MAXLINE+1) * sizeof (char) );

}


 
#ifdef UNIX
FILE *open_path(char *fname)  /* to open in read-only file fname searching for 
				 it through all path directories */
{
#define Mxdir 70
        char dir[Mxdir+1], *path, *deb, *fin;
        FILE *fich;
        sint lf, ltot;
 
        path=getenv("PATH"); 	/* get the list of path directories, 
					separated by :
    				*/
        if (path == NULL ) return fopen(fname,"r");
        lf=(sint)strlen(fname);
        deb=path;
        do
                {
                fin=strchr(deb,':');
                if(fin!=NULL)
                        { strncpy(dir,deb,fin-deb); ltot=fin-deb; }
                else
                        { strcpy(dir,deb); ltot=(sint)strlen(dir); }
                /* now one directory is in string dir */
                if( ltot + lf + 1 <= Mxdir)
                        {
                        dir[ltot]='/';
                        strcpy(dir+ltot+1,fname); /* now dir is appended with filename */
                        if( (fich = fopen(dir,"r") ) != NULL) break;
                        }
                else fich = NULL;
                deb=fin+1;
                }
        while (fin != NULL);
        return fich;
}
#endif


void get_help(char help_pointer)    /* Help procedure */
{	
	FILE *help_file;
	sint  i, number, nlines;
	Boolean found_help;
	char temp[MAXLINE+1];
	char token = '\0';
	char *digits = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	char *help_marker    = ">>HELP";

	extern char *help_file_name;

#ifdef VMS
        if((help_file=fopen(help_file_name,"r","rat=cr","rfm=var"))==NULL) {
            error("Cannot open help file [%s]",help_file_name);
            return;
        }
#else

#ifdef UNIX
        if((help_file=open_path(help_file_name))==NULL) {
             if((help_file=fopen(help_file_name,"r"))==NULL) {
                  error("Cannot open help file [%s]",help_file_name);
                  return;
             }
        }
        
#else
        if((help_file=fopen(help_file_name,"r"))==NULL) {
            error("Cannot open help file [%s]",help_file_name);
            return;
        }
#endif

#endif
/*		error("Cannot open help file [%s]",help_file_name);
		return;
	}
*/
	nlines = 0;
	number = -1;
	found_help = FALSE;

	while(TRUE) {
		if(fgets(temp,MAXLINE+1,help_file) == NULL) {
			if(!found_help)
				error("No help found in help file");
			fclose(help_file);
			return;
		}
		if(strstr(temp,help_marker)) {
                        token = ' ';
			for(i=strlen(help_marker); i<8; i++)
				if(strchr(digits, temp[i])) {
					token = temp[i];
					break;
				}
		}
		if(token == help_pointer) {
			found_help = TRUE;
			while(fgets(temp,MAXLINE+1,help_file)) {
				if(strstr(temp, help_marker)){
				  	if(usemenu) {
						fprintf(stdout,"\n");
				    		getstr("Press [RETURN] to continue",lin2);
				  	}
					fclose(help_file);
					return;
				}
				if(temp[0]!='<') {
			       		fputs(temp,stdout);
			       		++nlines;
				}
			       if(usemenu) {
			          if(nlines >= PAGE_LEN) {
				     	   fprintf(stdout,"\n");
			 	  	   getstr("Press [RETURN] to continue or  X  to stop",lin2);
				  	   if(toupper(*lin2) == 'X') {
						   fclose(help_file);
						   return;
				  	   }
				  	   else
						   nlines = 0;
				   }
			       }
			}
			if(usemenu) {
				fprintf(stdout,"\n");
				getstr("Press [RETURN] to continue",lin2);
			}
			fclose(help_file);
		}
	}
}

static void show_aln(void)         /* Alignment screen display procedure */
{
        FILE *file;
        sint  nlines;
        char temp[MAXLINE+1];
        char file_name[FILENAMELEN+1];

        if(output_clustal) strcpy(file_name,clustal_outname);
        else if(output_nbrf) strcpy(file_name,nbrf_outname);
        else if(output_gcg) strcpy(file_name,gcg_outname);
        else if(output_phylip) strcpy(file_name,phylip_outname);
        else if(output_gde) strcpy(file_name,gde_outname);

#ifdef VMS
        if((file=fopen(file_name,"r","rat=cr","rfm=var"))==NULL) {
#else
        if((file=fopen(file_name,"r"))==NULL) {
#endif
                error("Cannot open file [%s]",file_name);
                return;
        }

        fprintf(stdout,"\n\n");
        nlines = 0;

        while(fgets(temp,MAXLINE+1,file)) {
                fputs(temp,stdout);
                ++nlines;
                if(nlines >= PAGE_LEN) {
                        fprintf(stdout,"\n");
                        getstr("Press [RETURN] to continue or  X  to stop",lin2);
                        if(toupper(*lin2) == 'X') {
                                fclose(file);
                                return;
                        }
                        else
                                nlines = 0;
                }
        }
        fclose(file);
        fprintf(stdout,"\n");
        getstr("Press [RETURN] to continue",lin2);
}


void parse_params(Boolean xmenus)
{
	sint i,j,temp;
        char path[FILENAMELEN];


	Boolean do_align, do_convert, do_align_only, do_tree_only, do_tree, do_boot, do_profile, do_something;

	if (!xmenus)
	{
		fprintf(stdout,"\n\n\n");
		fprintf(stdout," CLUSTAL %s Multiple Sequence Alignments\n\n\n",revision_level);
	}

	do_align = do_convert = do_align_only = do_tree_only = do_tree = do_boot = do_profile = do_something = FALSE;

	*seqname=EOS;

/* JULIE 
	len=(sint)strlen(paramstr);
   Stop converting command line to lower case - unix, mac, pc are case sensitive
	for(i=0;i<len;++i) paramstr[i]=tolower(paramstr[i]);
*/

    numparams = check_param(args, params, param_arg);
	if (numparams <0) exit(1);

	if(sethelp != -1) {
		get_help('9');
		exit(1);
	}

	if(setoptions != -1) {
		fprintf(stdout,"clustalw option list:-\n");
		for (i=0;cmd_line_verb[i].str[0] != '\0';i++) {
			fprintf(stdout,"\t\t%c%s%s",COMMANDSEP,cmd_line_verb[i].str,cmd_line_type[cmd_line_verb[i].type]);
			if (cmd_line_verb[i].type == OPTARG) {
				if (cmd_line_verb[i].arg[0][0] != '\0')
					fprintf(stdout,"=%s",cmd_line_verb[i].arg[0]);
				for (j=1;cmd_line_verb[i].arg[j][0] != '\0';j++)
					fprintf(stdout," OR %s",cmd_line_verb[i].arg[j]);
			}
			fprintf(stdout,"\n");
		}
		for (i=0;cmd_line_file[i].str[0] != '\0';i++) {
			fprintf(stdout,"\t\t%c%s%s",COMMANDSEP,cmd_line_file[i].str,cmd_line_type[cmd_line_file[i].type]);
			if (cmd_line_file[i].type == OPTARG) {
				if (cmd_line_file[i].arg[0][0] != '\0')
					fprintf(stdout,"=%s",cmd_line_file[i].arg[0]);
				for (j=1;cmd_line_file[i].arg[j][0] != '\0';j++)
					fprintf(stdout," OR %s",cmd_line_file[i].arg[j]);
			}
			fprintf(stdout,"\n");
		}
		for (i=0;cmd_line_para[i].str[0] != '\0';i++) {
			fprintf(stdout,"\t\t%c%s%s",COMMANDSEP,cmd_line_para[i].str,cmd_line_type[cmd_line_para[i].type]);
			if (cmd_line_para[i].type == OPTARG) {
				if (cmd_line_para[i].arg[0][0] != '\0')
					fprintf(stdout,"=%s",cmd_line_para[i].arg[0]);
				for (j=1;cmd_line_para[i].arg[j][0] != '\0';j++)
					fprintf(stdout," OR %s",cmd_line_para[i].arg[j]);
			}
			fprintf(stdout,"\n");
		}
		exit(1);
	}



/***************************************************************************
*   check to see if 1st parameter does not start with '/' i.e. look for an *
*   input file as first parameter.   The input file can also be specified  *
*   by /infile=fname.                                                      *
****************************************************************************/
/* JULIE - moved to check_param()
	if(paramstr[0] != '/') {
		strcpy(seqname, params[0]);
	}
*/

/*** ? /alphabet=n */
        if(setalphabet != -1) {
                temp = 0;
                if(strlen(param_arg[setalphabet]) > 0)
                         if (sscanf(param_arg[setalphabet],"%d",&temp)!=1) {
                                fprintf(stdout,"Bad option for /alphabet (must be integer)\n");
                                temp = 0;
                         }
                if(temp > 0) 
			if(temp<=MAXALPHABET) nalphabet = temp;
			else fprintf(stdout,"Bad option for /alphabet (MAX = %d)\n",MAXALPHABET);
        }
/**************************************************/
/*  Look for /infile=file.ext on the command line */
/**************************************************/

	if(setinfile != -1) {
		if(strlen(param_arg[setinfile]) <= 0) {
			error("Bad sequence file name");
			exit(1);
		}
		strcpy(seqname, param_arg[setinfile]);
	}

	if(*seqname != EOS) {
		profile_no = 0;
		nseqs = readseqs((sint)1,FALSE);
		if(nseqs < 2) {
                	fprintf(stdout,
			"\nNo. of seqs. read = %d. No alignment!\n",(pint)nseqs);
			exit(1);
		}
		for(i = 1; i<=nseqs; i++) 
			info("Sequence %d: %-*s   %6.d",
			(pint)i,max_names,names[i],(pint)seqlen_array[i]);
		empty = FALSE;
		do_something = TRUE;
	}

	set_optional_param();

/*********************************************************/
/* Look for /profile1=file.ext  AND  /profile2=file2.ext */
/* You must give both file names OR neither.             */
/*********************************************************/

	if(setprofile1 != -1) {
		if(strlen(param_arg[setprofile1]) <= 0) {
			error("Bad profile 1 file name");
			exit(1);
		}
		strcpy(seqname, param_arg[setprofile1]);
		profile_no = 1;
		profile_input();
		if(nseqs <= 0) 
			exit(1);
		strcpy(profile1_name,seqname);
	}

	if(setprofile2 != -1) {
		if(strlen(param_arg[setprofile2]) <= 0) {
			error("Bad profile 2 file name");
			exit(1);
		}
		if(profile1_empty) {
			error("Only 1 profile file (profile 2) specified.");
			exit(1);
		}
		strcpy(seqname, param_arg[setprofile2]);
		profile_no = 2;
		profile_input();
		if(nseqs > profile1_nseqs) 
			do_something = do_profile = TRUE;
		else {
			error("No sequences read from profile 2");
			exit(1);
		}
		strcpy(profile2_name,seqname);
	}

/*************************************************************************/
/* Look for /tree or /bootstrap or /align or /usetree ******************/
/*************************************************************************/

	if (setbatch != -1)
		interactive=FALSE;

	if (setinteractive != -1)
		interactive=TRUE;

	if (interactive) {
		settree = -1;
		setbootstrap = -1;
		setalign = -1;
		setusetree = -1;
		setusetree1 = -1;
		setusetree2 = -1;
		setnewtree = -1;
		setconvert = -1;
	}

	if(settree != -1 )
		if(empty) {
			error("Cannot draw tree.  No input alignment file");
			exit(1);
		}
		else 
			do_tree = TRUE;

	if(setbootstrap != -1)
		if(empty) {
			error("Cannot bootstrap tree. No input alignment file");
			exit(1);
		}
		else {
			temp = 0;
			if(param_arg[setbootstrap] != NULL)
				 if (sscanf(param_arg[setbootstrap],"%d",&temp)!=1) {
                         fprintf(stdout,"Bad option for /bootstrap (must be integer)\n");
                         temp = 0;
                    };
			if(temp > 0)          boot_ntrials = temp;
			do_boot = TRUE;
		}

	if(setalign != -1)
		if(empty) {
			error("Cannot align sequences.  No input file");
			exit(1);
		}
		else 
			do_align = TRUE;

	if(setconvert != -1)
		if(empty) {
			error("Cannot convert sequences.  No input file");
			exit(1);
		}
		else 
			do_convert = TRUE;
 
	if(setusetree != -1)
		if(empty) {
			error("Cannot align sequences.  No input file");
			exit(1);
		}
		else  {
		        if(strlen(param_arg[setusetree]) == 0) {
				error("Cannot align sequences.  No tree file specified");
				exit(1);
		        }
                        else {
			        strcpy(phylip_tree_name, param_arg[setusetree]);
		        }
		        use_tree_file = TRUE;
		        do_align_only = TRUE;
		}

	if(setnewtree != -1)
		if(empty) {
			error("Cannot align sequences.  No input file");
			exit(1);
		}
		else  {
		        if(strlen(param_arg[setnewtree]) == 0) {
				error("Cannot align sequences.  No tree file specified");
				exit(1);
		        }
                        else {
			        strcpy(phylip_tree_name, param_arg[setnewtree]);
		        }
		    new_tree_file = TRUE;
			do_tree_only = TRUE;
		}
 
	if(setusetree1 != -1)
		if(profile1_empty) {
			error("Cannot align profiles.  No input file");
			exit(1);
		}
		else if(profile_type == SEQUENCE) {
			error("Invalid option /usetree1.");
			exit(1);
		}
		else  {
		        if(strlen(param_arg[setusetree1]) == 0) {
				error("Cannot align profiles.  No tree file specified");
				exit(1);
		        }
                        else {
			        strcpy(p1_tree_name, param_arg[setusetree1]);
		        }
		        use_tree1_file = TRUE;
		        do_align_only = TRUE;
		}

	if(setnewtree1 != -1)
		if(profile1_empty) {
			error("Cannot align profiles.  No input file");
			exit(1);
		}
		else if(profile_type == SEQUENCE) {
			error("Invalid option /newtree1.");
			exit(1);
		}
		else  {
		        if(strlen(param_arg[setnewtree1]) == 0) {
				error("Cannot align profiles.  No tree file specified");
				exit(1);
		        }
                        else {
			        strcpy(p1_tree_name, param_arg[setnewtree1]);
		        }
		    new_tree1_file = TRUE;
		}
 
	if(setusetree2 != -1)
		if(profile2_empty) {
			error("Cannot align profiles.  No input file");
			exit(1);
		}
		else if(profile_type == SEQUENCE) {
			error("Invalid option /usetree2.");
			exit(1);
		}
		else  {
		        if(strlen(param_arg[setusetree2]) == 0) {
				error("Cannot align profiles.  No tree file specified");
				exit(1);
		        }
                        else {
			        strcpy(p2_tree_name, param_arg[setusetree2]);
		        }
		        use_tree2_file = TRUE;
		        do_align_only = TRUE;
		}

	if(setnewtree2 != -1)
		if(profile2_empty) {
			error("Cannot align profiles.  No input file");
			exit(1);
		}
		else if(profile_type == SEQUENCE) {
			error("Invalid option /newtree2.");
			exit(1);
		}
		else  {
		        if(strlen(param_arg[setnewtree2]) == 0) {
				error("Cannot align profiles.  No tree file specified");
				exit(1);
		        }
                        else {
			        strcpy(p2_tree_name, param_arg[setnewtree2]);
		        }
		    new_tree2_file = TRUE;
		}
 

	if( (!do_tree) && (!do_boot) && (!empty) && (!do_profile) && (!do_align_only) && (!do_tree_only) && (!do_convert)) 
		do_align = TRUE;

/*** ? /quicktree  */
        if(setquicktree != -1)
		quick_pairalign = TRUE;

	
	if(interactive) {
		if (!xmenus) usemenu = TRUE;
		return;
	}


	if(!do_something) {
		error("No input file(s) specified");
		exit(1);
	}




/****************************************************************************/
/* Now do whatever has been requested ***************************************/
/****************************************************************************/


	if(do_profile) {
		if (profile_type == PROFILE) profile_align(p1_tree_name,p2_tree_name);
		else new_sequence_align(phylip_tree_name);
	}

	else if(do_align)
		align(phylip_tree_name);

        else if(do_convert) {
                get_path(seqname,path);
                if(!open_alignment_output(path)) exit(1);
                create_alignment_output(1,nseqs);
        }

        else if (do_align_only)
                get_tree(phylip_tree_name);

	else if(do_tree_only)
		make_tree(phylip_tree_name);

	else if(do_tree)
		phylogenetic_tree(phylip_tree_name,clustal_tree_name,dist_tree_name);

	else if(do_boot)
		bootstrap_tree(phylip_tree_name,clustal_tree_name);

	fprintf(stdout,"\n");
	exit(0);

/*******whew!***now*go*home****/
}


short * user_mat(char *str)
{
	short *mat;
        sint maxres;

        FILE *infile;

        if(usemenu)
                getstr("Enter name of the matrix file",lin2);
        else
                strcpy(lin2,str);

        if(*lin2 == EOS) return FALSE;

        if((infile=fopen(lin2,"r"))==NULL) {
                error("Cannot find matrix file [%s]",lin2);
                return FALSE;
        }

	strcpy(str, lin2);

	mat = read_user_matrix(str);

	return mat;
}


Boolean user_gappen(char *str)
{
        Boolean err;
        sint i,j;
        int gap;
        char *activity;
        static char line[MAXLINE+1];
        FILE *infile;

        if(usemenu)
                getstr("Enter name of User-defined Penalty File",lin2);
        else
                strcpy(lin2,str);

        if(*lin2 == EOS) return FALSE;

        if((infile=fopen(lin2,"r"))==NULL) {
                error("Cannot find penalty file [%s]",lin2);
                return FALSE;
        }

        strcpy(str, lin2);

	activity=(char *)ckalloc((nalphabet+2)*sizeof(char));
        while(fgets(line,MAXLINE+1,infile) != NULL) {
                if(blankline(line)) continue;
                for(i=0;i<=nalphabet;i++) activity[i]='\0';
                if((err=sscanf(line,"%s%d",activity,&gap))!=2) {
                        error("Bad format in penalty file");
			fclose(infile);
                        return FALSE;
                }
                if(strlen(activity)!=nalphabet) {
                        error("Bad format in penalty file, %s",activity);
			fclose(infile);
                        return FALSE;
                }

        }
	fclose(infile);
	ckfree(activity);

        return TRUE;
}


sint seq_input(Boolean append)
{
        sint i;
	sint local_nseqs;
	if(usemenu) {
fprintf(stdout,"\n\nSequences should all be in 1 file.\n");
fprintf(stdout,"\n7 formats accepted: \n");
fprintf(stdout,
"NBRF/PIR, EMBL/SwissProt, Pearson (Fasta), GDE, Clustal, GCG/MSF, RSF.\n\n\n");
	}

       if (append)
          local_nseqs = readseqs(nseqs+(sint)1,TRUE);
       else
          local_nseqs = readseqs((sint)1,FALSE);  /*  1 is the first seq to be read */
       if(local_nseqs < 0)               /* file could not be opened */
           { 
		return local_nseqs;
           }
       else if(local_nseqs == 0)         /* no sequences */
           {
	       error("No sequences in file!  Bad format?");
               return local_nseqs;
           }
       else 
           {
	   struct_penalties1 = struct_penalties2 = NONE;
	   if (gap_penalty_mask1 != NULL) gap_penalty_mask1=ckfree(gap_penalty_mask1);
	   if (gap_penalty_mask2 != NULL) gap_penalty_mask2=ckfree(gap_penalty_mask2);
	   if (ss_name1 != NULL) ss_name1=ckfree(ss_name1);
	   if (ss_name2 != NULL) ss_name2=ckfree(ss_name2);
	   
		if(append) nseqs+=local_nseqs;
		else nseqs=local_nseqs;
		if (usemenu) {
			fprintf(stdout,"\n\n");
                	for(i=1; i<=nseqs; i++) {
/* DES                         fprintf(stdout,"%s: = ",names[i]); */
                        	info("Sequence %d: %-*s   %6.d",
                        	(pint)i,max_names,names[i],(pint)seqlen_array[i]);
                	}	
                }	
			empty=FALSE;
	   }
	return local_nseqs;	
}







sint profile_input(void)   /* read a profile   */
{                                           /* profile_no is 1 or 2  */
        sint local_nseqs, i;
	
        if(profile_no == 2 && profile1_empty) 
           {
             error("You must read in profile number 1 first");
             return 0;
           }

    if(profile_no == 1)     /* for the 1st profile */
      {
       local_nseqs = readseqs((sint)1,FALSE); /* (1) means 1st seq to be read = no. 1 */
       if(local_nseqs == 0)         /* no sequences  */
           {
	       error("No sequences in file!  Bad format?");
           }
       else if (local_nseqs > 0)
           { 				/* success; found some seqs. */
		struct_penalties1 = NONE;
		if (gap_penalty_mask1 != NULL) gap_penalty_mask1=ckfree(gap_penalty_mask1);
		if (ss_name1 != NULL) ss_name1=ckfree(ss_name1);
                if (struct_penalties != NONE) /* feature table / mask in alignment */
                	{
					struct_penalties1 = struct_penalties;
					gap_penalty_mask1 = (char *)ckalloc((max_aln_length) * sizeof (char));
					for (i=0;i<max_aln_length;i++)
						gap_penalty_mask1[i] = gap_penalty_mask[i];
        				ss_name1 = (char *)ckalloc( (MAXNAMES+1) * sizeof (char));

					strcpy(ss_name1,ss_name);
if (debug>0) {
for (i=0;i<seqlen_array[1];i++)
	fprintf(stdout,"%c",gap_penalty_mask1[i]);
fprintf(stdout,"\n");
}
					}
                nseqs = profile1_nseqs = local_nseqs;
				info("No. of seqs=%d",(pint)nseqs);
				profile1_empty=FALSE;
				profile2_empty=TRUE;
	   }
      }
    else
      {			        /* first seq to be read = profile1_nseqs + 1 */
       local_nseqs = readseqs(profile1_nseqs+(sint)1,TRUE); 
       if(local_nseqs == 0)         /* no sequences */
           {
	       error("No sequences in file!  Bad format?");
           }
       else if(local_nseqs > 0)
           {
		struct_penalties2 = NONE;
		if (gap_penalty_mask2 != NULL) gap_penalty_mask2=ckfree(gap_penalty_mask2);
		if (ss_name2 != NULL) ss_name2=ckfree(ss_name2);
                if (struct_penalties != NONE) /* feature table / mask in alignment */
                	{
					struct_penalties2 = struct_penalties;
					gap_penalty_mask2 = (char *)ckalloc((max_aln_length) * sizeof (char));
					for (i=0;i<max_aln_length;i++)
						gap_penalty_mask2[i] = gap_penalty_mask[i];
        				ss_name2 = (char *)ckalloc( (MAXNAMES+1) * sizeof (char));
					strcpy(ss_name2,ss_name);
if (debug>0) {
for (i=0;i<seqlen_array[profile1_nseqs+1];i++)
	fprintf(stdout,"%c",gap_penalty_mask2[i]);
fprintf(stdout,"\n");
}
					}
				info("No. of seqs in profile=%d",(pint)local_nseqs);
                nseqs = profile1_nseqs + local_nseqs;
                info("Total no. of seqs     =%d",(pint)nseqs);
				profile2_empty=FALSE;
				empty = FALSE;
	   }

      }
	if (gap_penalty_mask != NULL) gap_penalty_mask=ckfree(gap_penalty_mask);
	if (ss_name != NULL) ss_name=ckfree(ss_name);

	if(local_nseqs<=0) return local_nseqs;
	
	if (usemenu) fprintf(stdout,"\n\n");
        for(i=profile2_empty?1:profile1_nseqs+1; i<=nseqs; i++) {
                info("Sequence %d: %-*s   %6.d",
                   (pint)i,max_names,names[i],(pint)seqlen_array[i]);
        }	

	return nseqs;
}





FILE *  open_output_file(char *prompt,      char *path, 
				char *file_name,   char *file_extension)
 
{	static char temp[FILENAMELEN+1];
	static char local_prompt[MAXLINE];
	FILE * file_handle;

/*	if (*file_name == EOS) {
*/		strcpy(file_name,path);
		strcat(file_name,file_extension);
/*	}
*/
	if(strcmp(file_name,seqname)==0) {
		warning("Output file name is the same as input file.");
		if (usemenu) {
			strcpy(local_prompt,"\n\nEnter new name to avoid overwriting ");
			strcat(local_prompt," [%s]: ");          
			fprintf(stdout,local_prompt,file_name);
			gets(temp);
			if(*temp != EOS) strcpy(file_name,temp);
		}
	}
	else if (usemenu) {
		strcpy(local_prompt,prompt);
		strcat(local_prompt," [%s]: ");          
		fprintf(stdout,local_prompt,file_name);
		gets(temp);
		if(*temp != EOS) strcpy(file_name,temp);
	}

#ifdef VMS
	if((file_handle=fopen(file_name,"w","rat=cr","rfm=var"))==NULL) {
#else
	if((file_handle=fopen(file_name,"w"))==NULL) {
#endif
		error("Cannot open output file [%s]",file_name);
		return NULL;
	}
	return file_handle;
}



FILE *  open_explicit_file(char *file_name)
{ 
	FILE * file_handle;

	if (*file_name == EOS) {
		error("Bad output file [%s]",file_name);
		return NULL;
	}
#ifdef VMS
	if((file_handle=fopen(file_name,"w","rat=cr","rfm=var"))==NULL) {
#else
	if((file_handle=fopen(file_name,"w"))==NULL) {
#endif
		error("Cannot open output file [%s]",file_name);
		return NULL;
	}
	return file_handle;
}









void align(char *phylip_name)
{ 
	char path[FILENAMELEN+1];
	FILE *tree;
	sint count;
	
        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg1");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	if(empty && usemenu) {
		error("No sequences in memory. Load sequences first.");
		return;
	}

	   struct_penalties1 = struct_penalties2 = NONE;
	   if (gap_penalty_mask1 != NULL) gap_penalty_mask1=ckfree(gap_penalty_mask1);
	   if (gap_penalty_mask2 != NULL) gap_penalty_mask2=ckfree(gap_penalty_mask2);
	   if (ss_name1 != NULL) ss_name1=ckfree(ss_name1);
	   if (ss_name2 != NULL) ss_name2=ckfree(ss_name2);


        get_path(seqname,path);
/* DES DEBUG 
	fprintf(stdout,"\n\n Seqname = %s  \n Path = %s \n\n",seqname,path);
*/
	if(usemenu || !interactive) {
        	if(!open_alignment_output(path)) return;
	}

	if (nseqs >= 2) {

        	get_path(seqname,path);
        	if (phylip_name[0]!=EOS) {
                	if((tree = open_explicit_file(
                	phylip_name))==NULL) return;
        	}
        	else {
                 	if((tree = open_output_file(
                	"\nEnter name for new GUIDE TREE           file  ",path,
                	phylip_name,"dnd")) == NULL) return;
        	}
	}

	if (save_parameters) create_parameter_output();

	if(reset_alignments_new || reset_alignments_all) reset_align();

        info("Start of Pairwise alignments");
        info("Aligning...");


        if (quick_pairalign)
           show_pair((sint)0,nseqs,(sint)0,nseqs);
        else
           pairalign((sint)0,nseqs,(sint)0,nseqs);

	if (nseqs >= 2) {

		guide_tree(tree,1,nseqs);
		info("Guide tree        file created:   [%s]",
                phylip_name);
	}

	
        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }

        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg2");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	count = malign((sint)0,phylip_name);
	
	if (count <= 0) return;

	if (usemenu) fprintf(stdout,"\n\n\n");
	
        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }
	create_alignment_output(1,nseqs);
        if (showaln && usemenu) show_aln();
	phylip_name[0]=EOS;

}





void new_sequence_align(char *phylip_name)
{ 
	char path[FILENAMELEN+1];
	char tree_name[FILENAMELEN+1],temp[MAXLINE+1];
	Boolean use_tree;
	FILE *tree;
	sint i,j,count;
	float dscore;
	Boolean save_ss2;
	
        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg1");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }
	if(profile1_empty && usemenu) {
		error("No profile in memory. Input 1st profile first.");
		return;
	}

	if(profile2_empty && usemenu) {
		error("No sequences in memory. Input sequences first.");
		return;
	}

        get_path(profile2_name,path);

        if(usemenu || !interactive) {
        	if(!open_alignment_output(path)) return;
	}

	new_seq = profile1_nseqs+1;

/* check for secondary structure information for list of sequences */

	save_ss2 = use_ss2;
	if (struct_penalties2 != NONE && use_ss2 == TRUE && (nseqs - profile1_nseqs >
1)) {
		warning("Warning: ignoring gap penalty mask for a list of sequences");
		use_ss2 = FALSE;
	}

	for (i=1;i<=new_seq;i++) {
     		for (j=i+1;j<=new_seq;j++) {
       			dscore = countid(i,j);
       			tmat[i][j] = ((double)100.0 - (double)dscore)/(double)100.0;
       			tmat[j][i] = tmat[i][j];
     		}
   	}

	tree_name[0] = EOS;
	use_tree = FALSE;
	if (nseqs >= 2) {
		if (check_tree && usemenu) {
			strcpy(tree_name,path);
			strcat(tree_name,"dnd");
#ifdef VMS
        	if((tree=fopen(tree_name,"r","rat=cr","rfm=var"))!=NULL) {
#else
        	if((tree=fopen(tree_name,"r"))!=NULL) {
#endif
		if (usemenu)
            	fprintf(stdout,"\nUse the existing GUIDE TREE file,  %s  (y/n) ? [y]: ",
                                           tree_name);
                gets(temp);
                if(*temp != 'n' && *temp != 'N') {
                    strcpy(phylip_name,tree_name);
                    use_tree = TRUE;
                }
                fclose(tree);
        	}
		}
		else if (!usemenu && use_tree_file) {
			use_tree = TRUE;
		}
	}
	
	if (save_parameters) create_parameter_output();

	if(reset_alignments_new || reset_alignments_all) {
/*
		reset_prf1();
*/
		reset_prf2();
	}
	else fix_gaps();



/* create the new tree file, if necessary */

	if (use_tree == FALSE) {

		if (nseqs >= 2) {
        		get_path(profile2_name,path);
        		if (phylip_name[0]!=EOS) {
                		if((tree = open_explicit_file(
                		phylip_name))==NULL) return;
        		}
        		else {
                 		if((tree = open_output_file(
                		"\nEnter name for new GUIDE TREE           file  ",path,
                		phylip_name,"dnd")) == NULL) return;
        		}
		}
        info("Start of Pairwise alignments");
        info("Aligning...");


        if (quick_pairalign)
           show_pair((sint)0,nseqs,new_seq-2,nseqs);
        else
           pairalign((sint)0,nseqs,new_seq-2,nseqs);

		if (nseqs >= 2) {
			guide_tree(tree,1,nseqs);
			info("Guide tree        file created:   [%s]",
               		phylip_name);
		}
	}
	
	if (new_tree_file) return;

        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }

        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg2");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	count = seqalign(new_seq-2,phylip_name);
	
	use_ss2 = save_ss2;
	
	if (count <= 0) return;

	if (usemenu) fprintf(stdout,"\n\n\n");
        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }
	
	create_alignment_output(1,nseqs);
        if (showaln && usemenu) show_aln();
	phylip_name[0]=EOS;



}





void make_tree(char *phylip_name)
{
	char path[FILENAMELEN+1];
	FILE *tree;
	
        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg1");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	if(empty) {
		error("No sequences in memory. Load sequences first.");
		return;
	}

	   struct_penalties1 = struct_penalties2 = NONE;
	   if (gap_penalty_mask1 != NULL) gap_penalty_mask1=ckfree(gap_penalty_mask1);
	   if (gap_penalty_mask2 != NULL) gap_penalty_mask2=ckfree(gap_penalty_mask2);
	   if (ss_name1 != NULL) ss_name1=ckfree(ss_name1);
	   if (ss_name2 != NULL) ss_name2=ckfree(ss_name2);

	if(reset_alignments_new || reset_alignments_all) reset_align();

        get_path(seqname,path);

	if (nseqs < 2) {
		error("Less than 2 sequences in memory. Phylogenetic tree cannot be built.");
		return;
	}

	if (save_parameters) create_parameter_output();

	info("Start of Pairwise alignments");
	info("Aligning...");


   
        if (quick_pairalign)
          show_pair((sint)0,nseqs,(sint)0,nseqs);
        else
          pairalign((sint)0,nseqs,(sint)0,nseqs);

	if (nseqs >= 2) {
        	get_path(seqname,path);
        	if (phylip_name[0]!=EOS) {
                	if((tree = open_explicit_file(
                	phylip_name))==NULL) return;
        	}
        	else {
                 	if((tree = open_output_file(
                	"\nEnter name for new GUIDE TREE           file  ",path,
                	phylip_name,"dnd")) == NULL) return;
        	}

		guide_tree(tree,1,nseqs);
		info("Guide tree        file created:   [%s]",
               	phylip_name);
	}
	
	if(reset_alignments_new || reset_alignments_all) reset_align();

	phylip_name[0]=EOS;

        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }

}









void get_tree(char *phylip_name)
{
	char path[FILENAMELEN+1],temp[MAXLINE+1];
	sint count;
	
        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg2");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	if(empty) {
		error("No sequences in memory. Load sequences first.");
		return;
	}
	   struct_penalties1 = struct_penalties2 = NONE;
	   if (gap_penalty_mask1 != NULL) gap_penalty_mask1=ckfree(gap_penalty_mask1);
	   if (gap_penalty_mask2 != NULL) gap_penalty_mask2=ckfree(gap_penalty_mask2);
	   if (ss_name1 != NULL) ss_name1=ckfree(ss_name1);
	   if (ss_name2 != NULL) ss_name2=ckfree(ss_name2);


        get_path(seqname,path);

        if(usemenu || !interactive) {
        	if(!open_alignment_output(path)) return;
	}

	if(reset_alignments_new || reset_alignments_all) reset_align();

        get_path(seqname,path);

        if (nseqs >= 2) {
          
        	if(usemenu) {
       			strcpy(phylip_name,path);
       			strcat(phylip_name,"dnd");

            fprintf(stdout,"\nEnter a name for the guide tree file [%s]: ",
                                           phylip_name);
                	gets(temp);
                	if(*temp != EOS)
                        	strcpy(phylip_name,temp);
        	}

        	if(usemenu || !interactive) {
#ifdef VMS
        		if((tree=fopen(phylip_name,"r","rat=cr","rfm=var"))==NULL) {
#else
        		if((tree=fopen(phylip_name,"r"))==NULL) {
#endif
                		error("Cannot open tree file [%s]",phylip_name);
                		return;
        		}
		}
	}
	else {
        	info("Start of Pairwise alignments");
        	info("Aligning...");


            if (quick_pairalign)
                show_pair((sint)0,nseqs,(sint)0,nseqs);
            else
		   		pairalign((sint)0,nseqs,(sint)0,nseqs);
	}

	if (save_parameters) create_parameter_output();

	count = malign(0,phylip_name);
	if (count <= 0) return;

	if (usemenu) fprintf(stdout,"\n\n\n");
        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }

	create_alignment_output(1,nseqs);
        if (showaln && usemenu) show_aln();

	phylip_name[0]=EOS;



}










void profile_align(char *p1_tree_name,char *p2_tree_name)
{
	char path[FILENAMELEN+1];
	char tree_name[FILENAMELEN+1];
	char temp[MAXLINE+1];
	Boolean use_tree1,use_tree2;
	FILE *tree;
	sint count,i,j,dscore;
	
        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg1");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	if(profile1_empty || profile2_empty) {
		error("No sequences in memory. Load sequences first.");
		return;
	}

	get_path(profile1_name,path);
	
        if(usemenu || !interactive) {
        	if(!open_alignment_output(path)) return;
	}

	if(reset_alignments_new || reset_alignments_all) {
		reset_prf1();
		reset_prf2();
	}
	else fix_gaps();

	tree_name[0] = EOS;
	use_tree1 = FALSE;
	if (profile1_nseqs >= 2) {
		if (check_tree && usemenu) {
			strcpy(tree_name,path);
			strcat(tree_name,"dnd");
#ifdef VMS
        	if((tree=fopen(tree_name,"r","rat=cr","rfm=var"))!=NULL) {
#else
        	if((tree=fopen(tree_name,"r"))!=NULL) {
#endif
            	fprintf(stdout,"\nUse the existing GUIDE TREE file for Profile 1,  %s  (y/n) ? [y]: ",
                                           tree_name);
                gets(temp);
                if(*temp != 'n' && *temp != 'N') {
                    strcpy(p1_tree_name,tree_name);
                    use_tree1 = TRUE;
                }
                fclose(tree);
        	}
		}
		else if (!usemenu && use_tree1_file) {
			use_tree1 = TRUE;
		}
	}
	tree_name[0] = EOS;
	use_tree2 = FALSE;
	get_path(profile2_name,path);
	if (nseqs-profile1_nseqs >= 2) {
		if (check_tree && usemenu) {
			strcpy(tree_name,path);
			strcat(tree_name,"dnd");
#ifdef VMS
        	if((tree=fopen(tree_name,"r","rat=cr","rfm=var"))!=NULL) {
#else
        	if((tree=fopen(tree_name,"r"))!=NULL) {
#endif
            	fprintf(stdout,"\nUse the existing GUIDE TREE file for Profile 2,  %s  (y/n) ? [y]: ",
                                           tree_name);
                gets(temp);
                if(*temp != 'n' && *temp != 'N') {
                    strcpy(p2_tree_name,tree_name);
                    use_tree2 = TRUE;
                }
                fclose(tree);
        	}
		}
		else if (!usemenu && use_tree2_file) {
			use_tree2 = TRUE;
		}
	}
				
	if (save_parameters) create_parameter_output();


	if (use_tree1 == FALSE)
		if (profile1_nseqs >= 2) {
                	for (i=1;i<=profile1_nseqs;i++) {
                        	for (j=i+1;j<=profile1_nseqs;j++) {
                                	dscore = countid(i,j);
                                	tmat[i][j] = (100.0 - dscore)/100.0;
                                	tmat[j][i] = tmat[i][j];
                        	}
                	}
        		get_path(profile1_name,path);
        		if (p1_tree_name[0]!=EOS) {
                		if((tree = open_explicit_file(p1_tree_name))==NULL) return;
        		}
        		else {
                 		if((tree = open_output_file(
                		"\nEnter name for new GUIDE TREE file for profile 1 ",path,
                		p1_tree_name,"dnd")) == NULL) return;
        		}

			guide_tree(tree,1,profile1_nseqs);
			info("Guide tree        file created:   [%s]",
               		p1_tree_name);
		}
	if (use_tree2 == FALSE)
		if(nseqs-profile1_nseqs >= 2) {
                	for (i=1+profile1_nseqs;i<=nseqs;i++) {
                        	for (j=i+1;j<=nseqs;j++) {
                                	dscore = countid(i,j);
                                	tmat[i][j] = (100.0 - dscore)/100.0;
                                	tmat[j][i] = tmat[i][j];
                        	}
                	}
        		if (p2_tree_name[0]!=EOS) {
                		if((tree = open_explicit_file(p2_tree_name))==NULL) return;
        		}
        		else {
        			get_path(profile2_name,path);
                 		if((tree = open_output_file(
                		"\nEnter name for new GUIDE TREE file for profile 2 ",path,
                		p2_tree_name,"dnd")) == NULL) return;
        		}
			guide_tree(tree,profile1_nseqs+1,nseqs-profile1_nseqs);
			info("Guide tree        file created:   [%s]",
               		p2_tree_name);
		}

	if (new_tree1_file || new_tree2_file) return;

/* do an initial alignment to get the pairwise identities between the two
profiles - used to set parameters for the final alignment */
	count = palign1();
	if (count == 0) return;

	reset_prf1();
	reset_prf2();

        if(save_log)
        {
                get_path(seqname,path);
                strcpy(save_log_filename,path);
                strcat(save_log_filename,"lg2");
                if ((save_log_fd=fopen(save_log_filename,"w"))==NULL)
                        error("Cannot open log file %s",save_log_filename);
        }

	count = palign2(p1_tree_name,p2_tree_name);

	if (count == 0) return;

	if(usemenu) fprintf(stdout,"\n\n\n");
        if(save_log && save_log_fd!=NULL)
        {
                fclose(save_log_fd);
                save_log_fd=NULL;
        }

	create_alignment_output(1,nseqs);
        if (showaln && usemenu) show_aln();

	p1_tree_name[0]=EOS;
	p2_tree_name[0]=EOS;



}





void clustal_out(FILE *clusout, sint fres, sint len, sint fseq, sint lseq)
{
	static DCHAR *seq1,cspace,cident1,cident2;
	static sint *seq_no;
	static sint *print_seq_no;
	char *ss_mask1, *ss_mask2;
	char 	    *temp;
	ECHAR val;
	sint ii,lv1,*catident1,*catident2,*ident,chunks;
	sint i,j,k;
	sint pos,ptr,tlen;
	sint line_length;

	for(i=0;i<nalphabet;i++)
		cspace.c[i]=cident1.c[i]=cident2.c[i]=' ';
	cident1.c[0]='#';
	cident2.c[0]='*';

	catident1= (sint *)ckalloc((max_aa+1) * sizeof(sint));
	catident2= (sint *)ckalloc((max_aa+1) * sizeof(sint));
	ident=(sint *)ckalloc((max_aa+3)*sizeof(sint));

	seq_no = (sint *)ckalloc((nseqs+1) * sizeof(sint));
	print_seq_no = (sint *)ckalloc((nseqs+1) * sizeof(sint));
	for (i=fseq;i<=lseq;i++)
        {
		print_seq_no[i] = seq_no[i] = 0;
                for(j=1;j<fres;j++) {
			val = seq_array[i][j];
			if((val >=0) || (val <=max_aa)) seq_no[i]++;
		}
        }


	seq1 = (DCHAR *)ckalloc((max_aln_length+1) * sizeof(DCHAR));

	
	fprintf(clusout,"CLUSTAL %s multiple sequence alignment\n\n",
				 revision_level);

/* decide the line length for this alignment - maximum is LINELENGTH */
/*
	line_length=PAGEWIDTH-max_names;
	line_length=line_length-line_length % 10;
	if (line_length > LINELENGTH) line_length=LINELENGTH;
*/
	if(cl_linewidth<=0 || cl_linewidth>1000)
	{
		error("Output line width out of range (1-1000)\n");
		return;
	}
	line_length=cl_linewidth;
	temp = (char *)ckalloc((line_length+1) * nalphabet * sizeof(char));

	chunks = len/line_length;
	if(len % line_length != 0)
		++chunks;
		
	for(lv1=1;lv1<=chunks;++lv1) {
		pos = ((lv1-1)*line_length)+1;
		ptr = (len<pos+line_length-1) ? len : pos+line_length-1;

		fprintf(clusout,"\n");
		
		if (output_struct_penalties == 1) {
			if (struct_penalties1 != NONE && use_ss1 == TRUE) {
				for(i=pos;i<=ptr;++i) {
					val=gap_penalty_mask1[i+fres-2];
					if (val == gap_pos1)
						temp[i-pos]='-';
					else
						temp[i-pos]=val;
				}
				temp[ptr-pos+1]=EOS;
				fprintf(clusout,"!GM_%-*s  %s\n",max_names,ss_name1,temp);
				}
		}
		if (output_struct_penalties == 1) {
			if (struct_penalties2 != NONE && use_ss2 == TRUE) {
				for(i=pos;i<=ptr;++i) {
					val=gap_penalty_mask2[i+fres-2];
					if (val == gap_pos1)
						temp[i-pos]='-';
					else
						temp[i-pos]=val;
				}
				temp[ptr-pos+1]=EOS;
				fprintf(clusout,"!GM_%-*s  %s\n",max_names,ss_name2,temp);
			}
		}
		
		for(ii=fseq;ii<=lseq;++ii) {
                        i=output_index[ii];
			print_seq_no[i] = 0;
			for(j=pos;j<=ptr;++j) {
				if (j+fres-1<=seqlen_array[i])
					val = seq_array[i][j+fres-1];
				else val = -3;
				if((val == -3) || (val == 253)) break;
				else if((val < 0) || (val >= max_aa))
                                        seq1[j]=gapchar();
				else {
					seq1[j]=cpchar(alphabet[val]);
					seq_no[i]++;
					print_seq_no[i]=1;
				}
			}
			for(;j<=ptr;++j) seq1[j]=gapchar();
			for(j=0,tlen=0;j<ptr-pos+1;j++) {
				for(k=0;k<nalphabet;k++)
				temp[tlen++]=seq1[pos+j].c[k];
			}
/*			strncpy(temp,&seq1[pos],ptr-pos+1);*/
			temp[tlen]=EOS;
			fprintf(clusout,"%-*s %s",max_names+5,names[i],temp);
			if (cl_seq_numbers && print_seq_no[i])
					fprintf(clusout," %d",seq_no[i]);
			fprintf(clusout,"\n");
		}
	
			
		for(i=pos;i<=ptr;++i) {
			seq1[i]=cpchar(cspace);
			for(k=0;k<max_aa;k++) 
				ident[k]=0;
			for(j=fseq;j<=lseq;++j) {
				if((seq_array[j][i] >=0) && 
				   (seq_array[j][i] < max_aa)) {
					for(k=0;k<max_aa;k++) {
						if(k==seq_array[j][i])
							++ident[k];
					}
				}
			}
			for(k=0;k<max_aa;k++) {
				if(ident[k]>=0.80*(float)nseqs) {
					seq1[i].c[0]='#';
				}	
				else if (ident[k]>=0.60*(float)nseqs) {
					if(seq1[i].c[0]==' ') seq1[i].c[0]='*';
				}
				else if (ident[k]>=0.40*(float)nseqs) {
					if(seq1[i].c[0]==' ') seq1[i].c[0]=':';
				}
				else if (ident[k]>=0.20*(float)nseqs) {
					if(seq1[i].c[0]==' ') seq1[i].c[0]='.';
				}
			}
		}
		for(j=0,tlen=0;j<ptr-pos+1;j++) {
			for(k=0;k<nalphabet;k++)
			temp[tlen++]=seq1[pos+j].c[k];
		}
		temp[tlen]=EOS;
		for(k=0;k<max_names+6;k++) fprintf(clusout," ");
		fprintf(clusout,"%s\n",temp);
	}
		

	seq1=ckfree((void *)seq1);
	temp=ckfree((void *)temp);
	catident1=ckfree((void *)catident1);
	catident2=ckfree((void *)catident2);
	if (struct_penalties1 == SECST && use_ss1 == TRUE) ckfree(ss_mask1);
	if (struct_penalties2 == SECST && use_ss2 == TRUE) ckfree(ss_mask2);
/* DES	ckfree(output_index); */
	
}



void gcg_out(FILE *gcgout, sint fres, sint len, sint fseq, sint lseq)
{
	DCHAR *seq, residue;
	sint val;
	sint *all_checks;
	sint i,ii,chunks,block;
	sint j,k,pos1,pos2;	
	long grand_checksum;

	seq = (DCHAR *)ckalloc((max_aln_length+1) * sizeof(DCHAR));
	all_checks = (sint *)ckalloc((lseq+1) * sizeof(sint));
	
	for(i=fseq; i<=lseq; i++) {
		for(j=fres; j<=fres+len-1; j++) {
			val = seq_array[i][j];
			if((val == -3) || (val == 253)) break;
			else if((val < 0) || (val >= max_aa))
				residue = gapchar();
                        else {
				residue = cpchar(alphabet[val]);
			}
			seq[j-fres+1] = cpchar(residue);
		}
/* pad any short sequences with gaps, to make all sequences the same length */
		for(; j<=fres+len-1; j++) 
			seq[j-fres+1] = gapchar();
		all_checks[i] = SeqGCGCheckSum(seq+1, (int)len);
	}	

	grand_checksum = 0;
	for(i=1; i<=nseqs; i++) grand_checksum += all_checks[output_index[i]];
	grand_checksum = grand_checksum % 10000;
        fprintf(gcgout,"PileUp\n\n");
	fprintf(gcgout,"\n\n   MSF:%5d  Type: ",(pint)len);
	fprintf(gcgout,"P");
	fprintf(gcgout,"    Check:%6ld   .. \n\n", (long)grand_checksum);
	for(ii=fseq; ii<=lseq; ii++)  {
                i = output_index[ii];
		fprintf(gcgout,
			" Name: %s oo  Len:%5d  Check:%6ld  Weight:  %.1f\n",
			names[i],(pint)len,(long)all_checks[i],(float)seq_weight[i]*100.0/(float)INT_SCALE_FACTOR);
        }
	fprintf(gcgout,"\n//\n");  

	chunks = len/GCG_LINELENGTH;
	if(len % GCG_LINELENGTH != 0) ++chunks;

	for(block=1; block<=chunks; block++) {
		fprintf(gcgout,"\n\n");
		pos1 = ((block-1) * GCG_LINELENGTH) + 1;
		pos2 = (len<pos1+GCG_LINELENGTH-1)? len : pos1+GCG_LINELENGTH-1;
		for(ii=fseq; ii<=lseq; ii++) {
                        i = output_index[ii];
			fprintf(gcgout,"\n%-*s ",max_names+5,names[i]);
			for(j=pos1, k=1; j<=pos2; j++, k++) {
/*
    JULIE -
    check for sint sequences - pad out with '.' characters to end of alignment
*/
				if (j+fres-1<=seqlen_array[i])
					val = seq_array[i][j+fres-1];
				else val = -3;
				if((val == -3) || (val == 253))
					residue = gapchar();
				else if((val < 0) || (val >= max_aa))
					residue = gapchar();
				else {
					residue = cpchar(alphabet[val]);
				}
				for(k=0;k<nalphabet;k++)
					fprintf(gcgout,"%c",residue.c[k]);
				if(j % 10 == 0) fprintf(gcgout," ");
			}
		}
	}
/* DES	ckfree(output_index); */

	seq=ckfree((void *)seq);
	all_checks=ckfree((void *)all_checks);
	
	fprintf(gcgout,"\n\n");
}



void phylip_out(FILE *phyout, sint fres, sint len, sint fseq, sint lseq)
{
	DCHAR residue;
	sint val;
	sint i,ii,chunks,block;	
	sint j,k,pos1,pos2;	
	sint name_len;
	Boolean warn;
	char **snames;
	
	snames=(char **)ckalloc((lseq-fseq+2)*sizeof(char *));
	name_len=0;
	for(i=fseq; i<=lseq; i++)  {
		snames[i]=(char *)ckalloc((11)*sizeof(char));
		ii=strlen(names[i]);
		strncpy(snames[i],names[i],10);
		if(name_len<ii) name_len=ii;
	}
	if(name_len>10) {
		warn=FALSE;
		for(i=fseq; i<=lseq; i++)  {
                	for(j=i+1;j<=lseq;j++) {
                        	if (strcmp(snames[i],snames[j]) == 0) 
					warn=TRUE;
                	}
        	}
		if(warn)
			warning("Truncating sequence names to 10 characters for PHYLIP output.\n"
			"Names in the PHYLIP format file are NOT unambiguous.");
		else
			warning("Truncating sequence names to 10 characters for PHYLIP output.");
	}


	chunks = len/GCG_LINELENGTH;
	if(len % GCG_LINELENGTH != 0) ++chunks;

	fprintf(phyout,"%6d %6d",(pint)nseqs,(pint)len);

	for(block=1; block<=chunks; block++) {
		pos1 = ((block-1) * GCG_LINELENGTH)+1;
		pos2 = (len<pos1+GCG_LINELENGTH-1)? len : pos1+GCG_LINELENGTH-1;
		for(ii=fseq; ii<=lseq; ii++)  {
                        i = output_index[ii];
			if(block == 1)  {
				fprintf(phyout,"\n%-10s ",snames[i]);
			}
			else
				fprintf(phyout,"\n           ");
			for(j=pos1, k=1; j<=pos2; j++, k++) {
				if (j+fres-1<=seqlen_array[i])
					val = seq_array[i][j+fres-1];
				else val = -3;
				if((val == -3) || (val == 253))
					break;
				else if((val < 0) || (val >= max_aa))
					residue = gapchar();
				else {
					residue = cpchar(alphabet[val]);
				}
				for(k=0;k<nalphabet;k++)
					fprintf(phyout,"%c",residue.c[k]);
				if(j % 10 == 0) fprintf(phyout," ");
			}
		}
		fprintf(phyout,"\n");
	}
/* DES	ckfree(output_index); */

	for(i=fseq;i<=lseq;i++)
		ckfree(snames[i]);
	ckfree(snames);
}





void nbrf_out(FILE *nbout, sint fres, sint len, sint fseq, sint lseq)
{
	DCHAR *seq, residue;
	sint val;
	sint i,ii,k;
	sint j,slen;	
	sint line_length;

	seq = (DCHAR *)ckalloc((max_aln_length+1) * sizeof(DCHAR));
	
/* decide the line length for this alignment - maximum is LINELENGTH */
	line_length=PAGEWIDTH-max_names;
	line_length=line_length-line_length % 10; /* round to a multiple of 10*/
	if (line_length > LINELENGTH) line_length=LINELENGTH;

	for(ii=fseq; ii<=lseq; ii++) {
                i = output_index[ii];
		fprintf(nbout, ">P1;");
		fprintf(nbout, "%s\n%s\n", names[i], titles[i]);
		slen = 0;
		for(j=fres; j<fres+len; j++) {
			val = seq_array[i][j];
			if((val == -3) || (val == 253))
				break;
			else if((val < 0) || (val >= max_aa))
				residue = gapchar();
			else {
				residue = cpchar(alphabet[val]);
			}
			seq[j-fres] = cpchar(residue);
			slen++;
		}
		for(j=1; j<=slen; j++) {
			for(k=0;k<nalphabet;k++)
				fprintf(nbout,"%c",seq[j-1].c[k]);
			if((j % line_length == 0) || (j == slen)) 
				fprintf(nbout,"\n");
		}
		fprintf(nbout,"*\n");
	}	
/* DES	ckfree(output_index);  */

	seq=ckfree((void *)seq);
}






void gde_out(FILE *gdeout, sint fres, sint len, sint fseq, sint lseq)
{
/*      static char *aacids = "XCSTPAGNDEQHRKMILVFYW";*/
/*		static char *nbases = "XACGT";	*/
	DCHAR *dseq, residue;
	char *seq;
	ECHAR val;
	char *ss_mask1, *ss_mask2;
	sint i,ii;
	sint j,k,slen;	
	sint line_length;

	dseq = (DCHAR *)ckalloc((max_aln_length+1) * sizeof(DCHAR));
	seq = (char *)ckalloc((max_aln_length+1) * sizeof(char));

/* decide the line length for this alignment - maximum is LINELENGTH */
	line_length=PAGEWIDTH-max_names;
	line_length=line_length-line_length % 10; /* round to a multiple of 10*/
	if (line_length > LINELENGTH) line_length=LINELENGTH;


	
	for(ii=fseq; ii<=lseq; ii++) {
                i = output_index[ii];
		fprintf(gdeout, "%%");
		fprintf(gdeout, "%s\n", names[i]);
		slen = 0;
		for(j=fres; j<fres+len; j++) {
			val = seq_array[i][j];
			if((val == -3) || (val == 253))
				break;
			else if((val < 0) || (val >= max_aa))
				residue = gapchar();
			else {
				residue=cpchar(alphabet[val]);
			}
				dseq[j-fres]=cpchar(residue);
			slen++;
		}
		for(j=1; j<=slen; j++) {
			for(k=0;k<nalphabet;k++)
				fprintf(gdeout,"%c",dseq[j-1].c[k]);
			if((j % line_length == 0) || (j == slen)) 
				fprintf(gdeout,"\n");
		}
	}	
/* DES	ckfree(output_index); */

	if (output_struct_penalties == 0 || output_struct_penalties == 2) {
		if (struct_penalties1 == SECST && use_ss1 == TRUE) {
			fprintf(gdeout,"\"SS_%-*s\n",max_names,ss_name1);
			for(i=fres; i<fres+len; i++) {
				val=ss_mask1[i-1];
				if (val == gap_pos1)
					seq[i-fres]='-';
				else
					seq[i-fres]=val;
			}
			seq[i-fres]=EOS;
			for(i=1; i<=len; i++) {
				fprintf(gdeout,"%c",seq[i-1]);
				if((i % line_length == 0) || (i == len)) 
					fprintf(gdeout,"\n");
			}
		}
		
		if (struct_penalties2 == SECST && use_ss2 == TRUE) {
			fprintf(gdeout,"\"SS_%-*s\n",max_names,ss_name2);
			for(i=fres; i<fres+len; i++) {
				val=ss_mask2[i-1];
				if (val == gap_pos1)
					seq[i-fres]='-';
				else
					seq[i-fres]=val;
			}
			seq[i]=EOS;
			for(i=1; i<=len; i++) {
				fprintf(gdeout,"%c",seq[i-1]);
				if((i % line_length == 0) || (i == len)) 
					fprintf(gdeout,"\n");
			}
		}
	}
	if (output_struct_penalties == 1 || output_struct_penalties == 2) {
		if (struct_penalties1 != NONE && use_ss1 == TRUE) {
			fprintf(gdeout,"\"GM_%-*s\n",max_names,ss_name1);
			for(i=fres; i<fres+len; i++) {
				val=gap_penalty_mask1[i-1];
				if (val == gap_pos1)
					seq[i-fres]='-';
				else
					seq[i-fres]=val;
			}
			seq[i]=EOS;
			for(i=1; i<=len; i++) {
				fprintf(gdeout,"%c",seq[i-1]);
				if((i % line_length == 0) || (i == len)) 
					fprintf(gdeout,"\n");
			}
		}
		
		if (struct_penalties2 != NONE && use_ss2 == TRUE) {
			fprintf(gdeout,"\"GM_%-*s\n",max_names,ss_name2);
			for(i=fres; i<fres+len; i++) {
				val=gap_penalty_mask2[i-1];
				if (val == gap_pos1)
					seq[i-fres]='-';
				else
					seq[i-fres]=val;
			}
			seq[i]=EOS;
			for(i=1; i<=len; i++) {
				fprintf(gdeout,"%c",seq[i-1]);
				if((i % line_length == 0) || (i == len)) 
					fprintf(gdeout,"\n");
			}
		}
	}
		
	if (struct_penalties1 == SECST && use_ss1 == TRUE) ckfree(ss_mask1);
	if (struct_penalties2 == SECST && use_ss2 == TRUE) ckfree(ss_mask2);
	
	dseq=ckfree((void *)dseq);
	seq=ckfree((void *)seq);
}


Boolean open_alignment_output(char *path)
{

	if(!output_clustal && !output_nbrf && !output_gcg &&
                 !output_phylip && !output_gde) {
                error("You must select an alignment output format");
                return FALSE;
        }

	if(output_clustal) 
		if (outfile_name[0]!=EOS) {
			strcpy(clustal_outname,outfile_name);
			if((clustal_outfile = open_explicit_file(
			clustal_outname))==NULL) return FALSE;
		}
		else {
		   	if((clustal_outfile = open_output_file(
		    	"\nEnter a name for the CLUSTAL output file ",path,
			clustal_outname,"aln"))==NULL) return FALSE;
		}
        if(output_nbrf)
                if (outfile_name[0]!=EOS) {
                        strcpy(nbrf_outname,outfile_name);
                        if((nbrf_outfile = open_explicit_file(
                        nbrf_outname))==NULL) return FALSE;
                }
                else
                        if((nbrf_outfile = open_output_file(
                        "\nEnter a name for the NBRF/PIR output file",path,
                        nbrf_outname,"pir"))==NULL) return FALSE;
        if(output_gcg)
                if (outfile_name[0]!=EOS) {
                        strcpy(gcg_outname,outfile_name);
                        if((gcg_outfile = open_explicit_file(
                        gcg_outname))==NULL) return FALSE;
                }
                else
                        if((gcg_outfile = open_output_file(
                        "\nEnter a name for the GCG output file     ",path,
                        gcg_outname,"msf"))==NULL) return FALSE;
        if(output_phylip)
                if (outfile_name[0]!=EOS) {
                        strcpy(phylip_outname,outfile_name);
                        if((phylip_outfile = open_explicit_file(
                        phylip_outname))==NULL) return FALSE;
                }
                else
                        if((phylip_outfile = open_output_file(
                        "\nEnter a name for the PHYLIP output file  ",path,
                        phylip_outname,"phy"))==NULL) return FALSE;
	if(output_gde) 
		if (outfile_name[0]!=EOS) {
			strcpy(gde_outname,outfile_name);
			if((gde_outfile = open_explicit_file(
			gde_outname))==NULL) return FALSE;
		}
		else
			if((gde_outfile = open_output_file(
		    	"\nEnter a name for the GDE output file     ",path,
			gde_outname,"gde"))==NULL) return FALSE;
	return TRUE;
}





void create_alignment_output(sint fseq, sint lseq)
{
	sint i,length;

	length=0;
        for (i=fseq;i<=lseq;i++)
                if (length < seqlen_array[i])
                        length = seqlen_array[i];
	if (usemenu) info("Consensus length = %d",(pint)length);

	if(output_clustal) {
		clustal_out(clustal_outfile, 1, length, fseq, lseq);
		fclose(clustal_outfile);
		info("CLUSTAL-Alignment file created  [%s]",clustal_outname);
	}
        if(output_nbrf)  {
                nbrf_out(nbrf_outfile, 1, length, fseq, lseq);
                fclose(nbrf_outfile);
                info("NBRF/PIR-Alignment file created [%s]",nbrf_outname);
        }
        if(output_gcg)  {
                gcg_out(gcg_outfile, 1, length, fseq, lseq);
                fclose(gcg_outfile);
                info("GCG-Alignment file created      [%s]",gcg_outname);
        }
        if(output_phylip)  {
                phylip_out(phylip_outfile, 1, length, fseq, lseq);
                fclose(phylip_outfile);
                info("PHYLIP-Alignment file created   [%s]",phylip_outname);
        }
	if(output_gde)  {
		gde_out(gde_outfile, 1, length, fseq, lseq);
		fclose(gde_outfile);
		info("GDE-Alignment file created      [%s]",gde_outname);
	}
}







static void reset_align(void)   /* remove gaps from older alignments (code =
gap_pos1) */
{		      				/* EXCEPT for gaps that were INPUT with the seqs.*/
	register sint sl;   		     /* which have  code = gap_pos2  */
	sint i,j;
	
	for(i=1;i<=nseqs;++i) {
		sl=0;
		for(j=1;j<=seqlen_array[i];++j) {
			if(seq_array[i][j] == gap_pos1 && (reset_alignments_new ||
reset_alignments_all)) continue;
			if(seq_array[i][j] == gap_pos2 && (reset_alignments_all)) continue;
			++sl;
			seq_array[i][sl]=seq_array[i][j];
		}
		seqlen_array[i]=sl;
	}
	
			
}



static void reset_prf1(void)   /* remove gaps from older alignments (code =
gap_pos1) */
{		      				/* EXCEPT for gaps that were INPUT with the seqs.*/
	register sint sl;   		     /* which have  code = gap_pos2  */
	sint i,j;
	
	if (struct_penalties1 != NONE) {
		sl=0;
		for (j=0;j<seqlen_array[1];++j) {
			if (gap_penalty_mask1[j] == gap_pos1 && (reset_alignments_new ||
reset_alignments_all)) continue;
			if (gap_penalty_mask1[j] == gap_pos2 && (reset_alignments_all)) continue;
			gap_penalty_mask1[sl]=gap_penalty_mask1[j];
			++sl;
		}
	}
	
	for(i=1;i<=profile1_nseqs;++i) {
		sl=0;
		for(j=1;j<=seqlen_array[i];++j) {
			if(seq_array[i][j] == gap_pos1 && (reset_alignments_new ||
reset_alignments_all)) continue;
			if(seq_array[i][j] == gap_pos2 && (reset_alignments_all)) continue;
			++sl;
			seq_array[i][sl]=seq_array[i][j];
		}
		seqlen_array[i]=sl;
	}
	
			
}



static void reset_prf2(void)   /* remove gaps from older alignments (code =
gap_pos1) */
{		      				/* EXCEPT for gaps that were INPUT with the seqs.*/
	register sint sl;   		     /* which have  code = gap_pos2  */
	sint i,j;
	
	if (struct_penalties2 != NONE) {
		sl=0;
		for (j=0;j<seqlen_array[profile1_nseqs+1];++j) {
			if (gap_penalty_mask2[j] == gap_pos1 && (reset_alignments_new ||
reset_alignments_all)) continue;
			if (gap_penalty_mask2[j] == gap_pos2 && (reset_alignments_all)) continue;
			gap_penalty_mask2[sl]=gap_penalty_mask2[j];
			++sl;
		}
	}
	
	
	for(i=profile1_nseqs+1;i<=nseqs;++i) {
		sl=0;
		for(j=1;j<=seqlen_array[i];++j) {
			if(seq_array[i][j] == gap_pos1 && (reset_alignments_new ||
reset_alignments_all)) continue;
			if(seq_array[i][j] == gap_pos2 && (reset_alignments_all)) continue;
			++sl;
			seq_array[i][sl]=seq_array[i][j];
		}
		seqlen_array[i]=sl;
	}
	
			
}



void fix_gaps(void)   /* fix gaps introduced in older alignments (code = gap_pos1) */
{		      				
	sint i,j;
	
	if (struct_penalties1 != NONE) {
		for (j=0;j<seqlen_array[1];++j) {
			if (gap_penalty_mask1[j] == gap_pos1)
				gap_penalty_mask1[j]=gap_pos2;
		}
	}
	
	for(i=1;i<=nseqs;++i) {
		for(j=1;j<=seqlen_array[i];++j) {
			if(seq_array[i][j] == gap_pos1)
				seq_array[i][j]=gap_pos2;
		}
	}
}

static sint find_match(char *probe, char *list[], sint n)
{
	sint i,j,len;
	sint count,match=0;

	len = (sint)strlen(probe);
	for (i=0;i<len;i++) {
		count = 0;
		for (j=0;j<n;j++) {
			if (probe[i] == list[j][i]) {
				match = j;
				count++;
			}
		}
		if (count == 0) return((sint)-1);
		if (count == 1) return(match);
	}
	return((sint)-1);
}

static void create_parameter_output(void)
{
	char parname[FILENAMELEN+1], temp[FILENAMELEN+1];
	char path[FILENAMELEN+1];
	FILE *parout;

        get_path(seqname,path);
        strcpy(parname,path);
        strcat(parname,"par");

	if(usemenu) {
        	fprintf(stdout,"\nEnter a name for the parameter output file [%s]: ",
                                           parname);
               	gets(temp);
               	if(*temp != EOS)
                       	strcpy(parname,temp);
       	}

/* create a file with execute permissions first */
	remove(parname);
/*
	fd = creat(parname, 0777);
	close(fd);
*/

        if((parout = open_explicit_file(parname))==NULL) return;

        fprintf(parout,"clustalw \\\n");
	if (!empty && profile1_empty) fprintf(parout,"/infile=%s \\\n",seqname);
	if (!profile1_empty) fprintf(parout,"/profile1=%s\\\n",profile1_name);
	if (!profile2_empty) fprintf(parout,"/profile2=%s \\\n",profile2_name);

	if (quick_pairalign) {
		fprintf(parout,"/quicktree \\\n");
		fprintf(parout,"/ktuple=%d \\\n",(pint)ktup);
     		fprintf(parout,"/window=%d \\\n",(pint)window);
     		fprintf(parout,"/pairgap=%d \\\n",(pint)wind_gap);
     		fprintf(parout,"/topdiags=%d \\\n",(pint)signif);    
     		if (percent) fprintf(parout,"/score=percent \\\n");      
     		else         fprintf(parout,"/score=absolute \\\n");      
	}
	else {
			fprintf(parout,"/pwmatrix=%s \\\n",pw_mtrxname);
			fprintf(parout,"/pwgapopen=%.2f \\\n",pw_go_penalty);
			fprintf(parout,"/pwgapext=%.2f \\\n",pw_ge_penalty);
	}

		fprintf(parout,"/matrix=%s \\\n",mtrxname);
		fprintf(parout,"/gapopen=%.2f \\\n",gap_open);
		fprintf(parout,"/gapext=%.2f \\\n",gap_extend);
	if(no_pref_penalties==FALSE) fprintf(parout,"/gappenfile=%s \\\n",gappenfile);

	fprintf(parout,"/maxdiv=%d \\\n",(pint)divergence_cutoff);
	if (!use_endgaps) fprintf(parout,"/endgaps \\\n");    

     		if (neg_matrix) fprintf(parout,"/negative \\\n");   
     		fprintf(parout,"/gapdist=%d \\\n",(pint)gap_dist);     
        if (output_gcg) fprintf(parout,"/output=gcg \\\n");
        else if (output_gde) fprintf(parout,"/output=gde \\\n");
        else if (output_nbrf) fprintf(parout,"/output=pir \\\n");
        else if (output_phylip) fprintf(parout,"/output=phylip \\\n");
	if (outfile_name[0]!=EOS) fprintf(parout,"/outfile=%s \\\n",outfile_name);
     	if (output_order==ALIGNED) fprintf(parout,"/outorder=aligned \\\n");  
     	else                      fprintf(parout,"/outorder=input \\\n");  
     	if (output_gde)
		if (lowercase) fprintf(parout,"/case=lower \\\n");
		else           fprintf(parout,"/case=upper \\\n");


        fprintf(parout,"/interactive\n");

	fclose(parout);
}

